using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;

namespace EdgeDetectionMethods
{
    public partial class Form1 : Form
    {
        private System.Drawing.Bitmap bitmapImage;
        private System.Drawing.Bitmap bitmapBackup;
        private double dZoom;
        private bool bFitToWindow;
        private string[] strFiles;
        private Bitmap[] bFiles;
        private Bitmap[] bPlayerFiles;
        private int iPlayerCounter;
        Timer timer;
        //private int iThumbViewAreaWidth;

        public Form1()
        {
            InitializeComponent();
            strFiles = new string[100];
            bFiles = new Bitmap[100];
            bFitToWindow = false;
            //this.iThumbViewAreaWidth = 100;
            bitmapImage = new Bitmap(2, 2);
            dZoom = 1;
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            //base.OnPaint(e);
            Graphics g = e.Graphics;

            if (this.bitmapBackup == null)
                this.undoToolStripMenuItem.Enabled = false;
            else
                this.undoToolStripMenuItem.Enabled = true;

            /*if (strFiles[0] != null)
            {
                double dZoomRate;
                int count = 1;
                int iPrevHeight = 25;
                foreach (string image in strFiles)
                    if (image != null)
                    {
                        dZoomRate = (80.00 / (double)((Bitmap)Bitmap.FromFile(image)).Width);
                        g.DrawImage((Bitmap)Bitmap.FromFile(image), this.AutoScrollPosition.X + 10, this.AutoScrollPosition.Y + iPrevHeight, (int)(((Bitmap)Bitmap.FromFile(image)).Width * dZoomRate), (int)(((Bitmap)Bitmap.FromFile(image)).Height * dZoomRate));
                        iPrevHeight = this.AutoScrollPosition.Y + iPrevHeight + (int)(((Bitmap)Bitmap.FromFile(image)).Height * dZoomRate) + 10;
                        count++;
                    }
            }*/

            //if (strFiles[0] != null)
                //g.DrawImage(this.bitmapImage, this.AutoScrollPosition.X + this.iThumbViewAreaWidth, this.AutoScrollPosition.Y + this.menuStrip1.Height, (int)(this.bitmapImage.Width * dZoom), (int)(this.bitmapImage.Height * dZoom));
            //else

            if (strFiles[0] == null)
            {
                this.windowToolStripMenuItem.Enabled = false;
                this.playEdgeVideoToolStripMenuItem.Enabled = false;
            }
            else
            {
                this.windowToolStripMenuItem.Enabled = true;
                this.playEdgeVideoToolStripMenuItem.Enabled = true;
            }

            g.DrawImage(this.bitmapImage, this.AutoScrollPosition.X, this.AutoScrollPosition.Y + this.menuStrip1.Height, (int)(this.bitmapImage.Width * dZoom), (int)(this.bitmapImage.Height * dZoom));
            
        }

        private void openFile(object sender, System.EventArgs e)
        {
            bFitToWindow = false;
            OpenFileDialog openFileDialog = new OpenFileDialog();

            dZoom = 1.0;

            openFileDialog.InitialDirectory = Environment.SpecialFolder.MyPictures.ToString();// "c:\\";
            openFileDialog.Filter = "Bitmap files (*.bmp)|*.bmp|Jpeg files (*.jpg)|*.jpg|Tiff files (*.tiff)|*.tiff|All valid files (*.bmp/*.jpg)|*.bmp/*.jpg";
            openFileDialog.FilterIndex = 2;
            openFileDialog.RestoreDirectory = true;

            if (((System.Windows.Forms.ToolStripMenuItem)sender).Text == "Open Se&quence")
                openFileDialog.Multiselect = true;
            else
                openFileDialog.Multiselect = false;

            if (DialogResult.OK == openFileDialog.ShowDialog())
            {
                if (openFileDialog.Multiselect == true && openFileDialog.FileNames.Length > 100)
                {
                    MessageBox.Show("Please select less than 100 files");
                    return;
                }

                Array.Clear(strFiles, 0, strFiles.Length);
                Array.Clear(openFileDialog.FileNames, 0, openFileDialog.FileNames.Length);
                Array.Clear(bFiles, 0, bFiles.Length);
                
                while(this.windowToolStripMenuItem.DropDownItems.Count != 0)
                    this.windowToolStripMenuItem.DropDownItems.RemoveAt(0);

                this.bitmapImage = (Bitmap)Bitmap.FromFile(openFileDialog.FileName, false);
                this.AutoScroll = true;
                this.AutoScrollMinSize = new Size((int)(this.bitmapImage.Width * dZoom), this.menuStrip1.Height + (int)(this.bitmapImage.Height * dZoom));
                this.Text = "Edge Detector Methods - " + openFileDialog.FileName;
                this.applyEdgeDetectionFilterToolStripMenuItem.Enabled = true;
                this.applyFilterToolStripMenuItem.Enabled = true;
                this.editToolStripMenuItem.Enabled = true;
                int x = 0;
                if (((System.Windows.Forms.ToolStripMenuItem)sender).Text == "Open Se&quence")
                {
                    foreach (string strFile in openFileDialog.FileNames)
                    {
                        ToolStripMenuItem nItem = new ToolStripMenuItem(strFile.Substring(strFile.LastIndexOf("\\")+1));
                        nItem.Click += new EventHandler(this.changeWindow);
                        nItem.MouseHover += new EventHandler(this.changeWindow);
                        windowToolStripMenuItem.DropDownItems.Add(nItem);
                        this.bFiles[x] = (Bitmap)Bitmap.FromFile(openFileDialog.FileNames[x], false);
                        x++;
                    }
                    openFileDialog.FileNames.CopyTo(strFiles, 0);
                }
                    

                this.Invalidate();
            }
        }

        private void closeEdgeDetectionMethods(object sender, System.EventArgs e)
        {
            this.Close();
        }

        private void ApplyKirsh(object sender, System.EventArgs e)
        {
            GetThreshold dlg = new GetThreshold();
            int[] x = new int[1];
            if (DialogResult.OK == dlg.ShowDialog(this))
            {
                bitmapBackup = (Bitmap)this.bitmapImage.Clone();
                //if (EdgeDetectionMethods.GrayScale(bitmapImage))
                    if (EdgeDetectionMethods.BasicEdgeDetect(bitmapImage, System.Convert.ToByte(dlg.txtBoxThreshold.Text), "KIRSH", x))
                        this.Invalidate();
            }
        }

        private void ApplyPrewitt(object sender, System.EventArgs e)
        {
            GetThreshold dlg = new GetThreshold();
            int[] x = new int[1];
            if (DialogResult.OK == dlg.ShowDialog(this))
            {
                bitmapBackup = (Bitmap)this.bitmapImage.Clone();
                //if (EdgeDetectionMethods.GrayScale(bitmapImage))
                    if (EdgeDetectionMethods.BasicEdgeDetect(bitmapImage, System.Convert.ToByte(dlg.txtBoxThreshold.Text), "PREWITT", x))
                        this.Invalidate();
            }
        }

        private void ApplySobel(object sender, System.EventArgs e)
        {
            GetThreshold dlg = new GetThreshold();
            int[] x = new int[1];
            if (DialogResult.OK == dlg.ShowDialog(this))
            {
                bitmapBackup = (Bitmap)this.bitmapImage.Clone();
                //if (EdgeDetectionMethods.GrayScale(bitmapImage))
                    if (EdgeDetectionMethods.BasicEdgeDetect(bitmapImage, System.Convert.ToByte(dlg.txtBoxThreshold.Text), "SOBEL", x))
                        this.Invalidate();
            }
        }

        private void ApplyCustom(object sender, System.EventArgs e)
        {
            GetCustomMatrix getMatrix = new GetCustomMatrix();
            
            if (DialogResult.OK == getMatrix.ShowDialog(this))
            {int[] x = { System.Convert.ToInt32(getMatrix.maskedTextBox1.Text), System.Convert.ToInt32(getMatrix.maskedTextBox2.Text), System.Convert.ToInt32(getMatrix.maskedTextBox3.Text), System.Convert.ToInt32(getMatrix.maskedTextBox4.Text),
                                    System.Convert.ToInt32(getMatrix.maskedTextBox5.Text), System.Convert.ToInt32(getMatrix.maskedTextBox6.Text), System.Convert.ToInt32(getMatrix.maskedTextBox7.Text), System.Convert.ToInt32(getMatrix.maskedTextBox8.Text),
                                    System.Convert.ToInt32(getMatrix.maskedTextBox9.Text), System.Convert.ToInt32(getMatrix.maskedTextBox10.Text), System.Convert.ToInt32(getMatrix.maskedTextBox11.Text) };
            
                GetThreshold dlg = new GetThreshold();
                if (DialogResult.OK == dlg.ShowDialog(this))
                {
                    bitmapBackup = (Bitmap)this.bitmapImage.Clone();
                    //if (EdgeDetectionMethods.GrayScale(bitmapImage))
                    if (EdgeDetectionMethods.BasicEdgeDetect(bitmapImage, System.Convert.ToByte(dlg.txtBoxThreshold.Text), "SOBEL", x))
                        this.Invalidate();
                }
            }
            
        }

        private void ApplyHorizontal(object sender, System.EventArgs e)
        {
            bitmapBackup = (Bitmap)this.bitmapImage.Clone();
            //if (EdgeDetectionMethods.GrayScale(bitmapImage))
            if (EdgeDetectionMethods.HorizontalEdgeDetection(this.bitmapImage))
                this.Invalidate();
        }

        private void ApplyVertical(object sender, System.EventArgs e)
        {
            bitmapBackup = (Bitmap)this.bitmapImage.Clone();
            //if (EdgeDetectionMethods.GrayScale(bitmapImage))
            if (EdgeDetectionMethods.VerticalEdgeDetection(this.bitmapImage))
                this.Invalidate();
        }

        private void Undo(object sender, System.EventArgs e)
        {
            Bitmap temp = (Bitmap)this.bitmapImage.Clone();
            bitmapImage = (Bitmap)this.bitmapBackup.Clone();
            bitmapBackup = (Bitmap)temp.Clone();
            this.Invalidate();
        }

        private void saveAsFile(object sender, System.EventArgs e)
        {
            SaveFileDialog saveDialog = new SaveFileDialog();
            saveDialog.InitialDirectory = Environment.SpecialFolder.MyPictures.ToString();
            saveDialog.Filter = "Bitmap files (*.bmp)|*.bmp|Jpeg files (*.jpg)|*.jpg|All valid files (*.bmp/*.jpg)|*.bmp/*.jpg" ;
            saveDialog.FilterIndex = 1;
            saveDialog.RestoreDirectory = true;

            if (DialogResult.OK == saveDialog.ShowDialog())
                this.bitmapImage.Save(saveDialog.FileName);
        }

        private void SaveFile(object sender, System.EventArgs e)
        {
            this.bitmapImage.Save(bitmapImage.ToString());
        }

        private void GrayScale(object sender, System.EventArgs e)
        {
            this.bitmapBackup = (Bitmap)this.bitmapImage.Clone();
            if(EdgeDetectionMethods.GrayScale(bitmapImage))
                this.Invalidate();
        }

        private void MicrosoftSepiaTone(object sender, System.EventArgs e)
        {
            this.bitmapBackup = (Bitmap)this.bitmapImage.Clone();
            if (EdgeDetectionMethods.SepiaMicrosoft(bitmapImage))
                this.Invalidate();
        }

        private void BlurImage(object sender, System.EventArgs e)
        {
            GetThreshold dlg = new GetThreshold("Blur");
            if(DialogResult.OK == dlg.ShowDialog(this))
            {
                this.bitmapBackup = (Bitmap)this.bitmapImage.Clone();
                if (EdgeDetectionMethods.blurImage(bitmapImage, System.Convert.ToInt32(dlg.txtBoxThreshold.Text)))
                    this.Invalidate();
            }
        }

        private void changeWindow(object sender, System.EventArgs e)
        {
            int x;
            for (x = 0; x < strFiles.Length-1; x++)
                if (strFiles[x].IndexOf(((System.Windows.Forms.ToolStripMenuItem)sender).Text) > -1)
                {
                    this.bitmapImage = this.bFiles[x];
                    break;
                }
            this.Invalidate();
        }

        private void onTimer(object sender, System.EventArgs e)
        {
            if (this.bPlayerFiles[this.iPlayerCounter] == null | this.iPlayerCounter == this.bPlayerFiles.Length)
                            this.iPlayerCounter = 0;
            this.bitmapImage = this.bPlayerFiles[iPlayerCounter];
            this.iPlayerCounter++;
            
            this.Invalidate();
        }

        private void playEdgeVideo(object sender, System.EventArgs e)
        {
            if (this.playEdgeVideoToolStripMenuItem.Text == "&Play Edge Video With" && ((System.Windows.Forms.ToolStripMenuItem)sender).Text != "&Play Edge Video With")
            {
                
                GetThreshold dlg = new GetThreshold();
                int[] x = new int[1];
                
                if (DialogResult.OK == dlg.ShowDialog(this))
                {
                    int count = 0;
                    this.playEdgeVideoToolStripMenuItem.Visible = false;
                    this.stopEdgeVideoToolStripMenuItem.Visible = true;
                    bitmapBackup = (Bitmap)this.bitmapImage.Clone();

                    this.bPlayerFiles = new Bitmap[this.bFiles.Length];
                    foreach(Bitmap image in this.bFiles)
                    {
                        if (this.bFiles[count] != null)
                        {
                            
                            this.bPlayerFiles[count] = (Bitmap)this.bFiles[count].Clone();
                            EdgeDetectionMethods.GrayScale(this.bPlayerFiles[count]);
                            EdgeDetectionMethods.blurImage(this.bPlayerFiles[count], 4);
                            switch(((System.Windows.Forms.ToolStripMenuItem)sender).Text)
                            {
                                case "Kirsh":
                                    EdgeDetectionMethods.BasicEdgeDetect(this.bPlayerFiles[count], System.Convert.ToByte(dlg.txtBoxThreshold.Text), "KIRSH", x);
                                    break;
                                case "Prewitt":
                                    EdgeDetectionMethods.BasicEdgeDetect(this.bPlayerFiles[count], System.Convert.ToByte(dlg.txtBoxThreshold.Text), "PREWITT", x);
                                    break;
                                case "Sobel":
                                    EdgeDetectionMethods.BasicEdgeDetect(this.bPlayerFiles[count], System.Convert.ToByte(dlg.txtBoxThreshold.Text), "SOBEL", x);
                                    break;
                                case "Horizontal":
                                    EdgeDetectionMethods.HorizontalEdgeDetection(this.bPlayerFiles[count]);
                                    break;
                                case "Vertical":
                                    EdgeDetectionMethods.VerticalEdgeDetection(this.bPlayerFiles[count]);
                                    break;

                            }
                            count++;
                        }
                        else
                            break;
                    }
                    this.iPlayerCounter = 0;
                    timer = new Timer();

                    timer.Interval = 250;
                    timer.Enabled = true;
                    timer.Tick += new EventHandler(this.onTimer);
                }
            }
        }

        private void stopEdgeVideo(object sender, System.EventArgs e)
        {
            Array.Clear(this.bPlayerFiles, 0, this.bPlayerFiles.Length);
            timer.Stop();
            timer.Dispose();
            this.playEdgeVideoToolStripMenuItem.Visible = true;
            this.stopEdgeVideoToolStripMenuItem.Visible = false;
            this.bitmapImage = this.bitmapBackup;
            this.Invalidate();
        }

        private void takeZoom(object sender, System.EventArgs e)
        {
            bFitToWindow = false;
            switch (((System.Windows.Forms.ToolStripMenuItem)sender).Text)
            {
                case "&10%":
                    dZoom = .1;
                    break;
                case "&20%":
                    dZoom = .2;
                    break;
                case "&25%":
                    dZoom = .25;
                    break;
                case "&30%":
                    dZoom = .3;
                    break;
                case "&40%":
                    dZoom = .4;
                    break;
                case "&50%":
                    dZoom = .5;
                    break;
                case "&60%":
                    dZoom = .6;
                    break;
                case "&70%":
                    dZoom = .7;
                    break;
                case "&75%":
                    dZoom = .75;
                    break;
                case "&80%":
                    dZoom = .8;
                    break;
                case "&90%":
                    dZoom = .9;
                    break;
                case "100%":
                    dZoom = 1;
                    break;
                case "150%":
                    dZoom = 1.5;
                    break;
                case "200%":
                    dZoom = 2;
                    break;
                case "&Fit To Window":
                    dZoom = ((double)(this.Width-35) / (double)this.bitmapImage.Width);
                    bFitToWindow = true;
                    break;
                case "&Custom":
                    GetThreshold dlg = new GetThreshold("Zoom");
                    if (DialogResult.OK == dlg.ShowDialog(this))
                        dZoom = System.Convert.ToDouble(dlg.txtBoxThreshold.Text);
                    
                    break;
            }
            this.AutoScrollMinSize = new Size((int)(bitmapImage.Width * dZoom), this.menuStrip1.Height + (int)(bitmapImage.Height * dZoom));
            this.Invalidate();
                    
        }

        private void onScreenResize(object sender, System.EventArgs e)
        {
            if (!bFitToWindow)
                return;

            dZoom = ((double)(this.Width - 35) / (double)this.bitmapImage.Width);
            this.AutoScrollMinSize = new Size((int)(bitmapImage.Width * dZoom), this.menuStrip1.Height + (int)(bitmapImage.Height * dZoom));
            this.Invalidate();
        }
    }
}